# coding:utf-8
import getpass
import subprocess as subs
import crypt
import csv
import logging

logging.basicConfig(level=logging.INFO)


def insert(file, file_data):
    with open(file, "w", encoding="utf-8") as f:
        f.write(file_data)


# Replaces the string in the file


def alter(file, old_str, new_str):
    file_data = ""

    try:
        file_data = alter_insert(file, old_str, new_str)

    except FileNotFoundError:
        logging.info("The file does not exist")
        pass
    insert(file, file_data)


def alter_insert(file, old_str, new_str):
    file_data = ""
    with open(file, "r", encoding="utf-8") as f:
        for line in f:
            if old_str in line:
                line = line.replace(old_str, new_str)
            file_data += line
    return file_data


def alter_after(file, find_str, new_str):
    file_data = ""
    try:
        file_data = alter_after_insert(file, find_str, new_str)
    except FileNotFoundError:
        logging.info("The file does not exist")
        return
    insert(file, file_data)


def alter_after_insert(file, find_str, new_str):
    file_data = ''
    with open(file, "r", encoding="utf-8") as f:
        for line in f:
            if find_str in line:
                begin = line[:line.find(find_str)]
                line = begin + find_str + new_str
            file_data += line
    return file_data


def add_after(file, find_str, new_str):
    file_data = ""
    try:
        file_data = add_after_insert(file, find_str, new_str)

    except FileNotFoundError:
        logging.info("The file does not exist")
        pass
    insert(file, file_data)


def add_after_insert(file, find_str, new_str):
    file_data = ""
    with open(file, "r", encoding="utf-8") as f:
        for line in f:
            if find_str in line:
                file_data += line
                file_data += new_str
                continue
            file_data += line
    return file_data


def read_csv(filename):
    dic = {}
    li = []
    with open(filename, newline='') as csvf:
        reader = csv.reader(csvf)
        for row in reader:
            li.append(row)

    for i in li:
        dic.update({i[0]: i[1]})
    return dic


def change_kick_start(fusion_kick_start, ip):
    file_data = """#version=DEVEL
# Use graphical install
graphical
#Use http installation source
url --url=http://ip/FusionOS/  

%packages
@^server-product-environment                   
 
%end
 
#add
 
# Root password
rootpw --iscrypted 
"""

    command_syn("mkdir -m 755 /var/www/html/ks/")
    with open(fusion_kick_start, "w", encoding="utf-8") as f:
        f.write(file_data)

    while 1:
        password_input = getpass.getpass("Please enter root password you want： ")
        password_input2 = getpass.getpass("Please enter it again: ")
        if password_input == password_input2:
            logging.info("successfully")
            break
        else:
            logging.info("two inputs are inconsistent , please try again")
    password_output = crypt.crypt(password_input)
    alter_after(fusion_kick_start, "rootpw --iscrypted", " " + password_output)

    # Modify the configuration according to the csv file
    dic2 = read_csv('/etc/auto-pxe/ks_cfg.csv')
    s = "http://%s/FusionOS/\n" % ip
    alter_after(fusion_kick_start, "url --url=", s)

    # The following are custom configurations
    data_ks = ""
    for _, v in dic2.items():
        if v != "":
            data_ks += v
            data_ks += '\n'

    alter_after(fusion_kick_start, "add\n", data_ks)


def x86grub(ip, iso_name):
    files = get_file_by_path('/mnt/images/pxeboot/')
    for i in files:
        file = "cp -r /mnt/images/pxeboot/%s /var/lib/tftpboot/" % i
        command_syn(file)

    command_syn("cp /mnt/EFI/BOOT/BOOTX64.EFI /var/lib/tftpboot/")
    command_syn("cp /mnt/EFI/BOOT/grubx64.efi /var/lib/tftpboot/")
    command_syn("cp /mnt/EFI/BOOT/grub.cfg /var/lib/tftpboot/")
    command_syn("mkdir -m 755 -p /var/lib/tftpboot/images/pxeboot")
    command_syn("cp /var/lib/tftpboot/vmlinuz /var/lib/tftpboot/images/pxeboot")
    command_syn("cp /var/lib/tftpboot/initrd.img /var/lib/tftpboot/images/pxeboot")
    chmod_by_file("/var/lib/tftpboot/images")

    grub = "/var/lib/tftpboot/grub.cfg"
    alter(grub, '''set default="1"''', '''set default="0"''')
    s = " '%s' \n" % iso_name[:-4]
    alter_after(grub, "search --no-floppy --set=root -l", s)

    add_ip = "        set root=(tftp,%s)\n" % ip
    add_after(grub, "menuentry 'Install FusionOS 23'", add_ip)
    add_after(grub, "menuentry 'Test this media & install FusionOS", add_ip)
    s = " quiet inst.ks=http://%s/ks/FusionOS-ks.cfg\n" % ip
    alter_after(grub, "linuxefi /images/pxeboot/vmlinuz", s)


def armgrub(ip, iso_name):
    files = get_file_by_path('/mnt/images/pxeboot/')
    for i in files:
        file = "cp -r /mnt/images/pxeboot/%s /var/lib/tftpboot/" % i
        command_syn(file)

    command_syn("cp /mnt/EFI/BOOT/BOOTAA64.EFI /var/lib/tftpboot/")
    command_syn("cp /mnt/EFI/BOOT/grubaa64.efi /var/lib/tftpboot/")
    command_syn("cp /mnt/EFI/BOOT/grub.cfg /var/lib/tftpboot/")
    command_syn("mkdir -m 755 -p /var/lib/tftpboot/images/pxeboot")
    command_syn("cp /var/lib/tftpboot/vmlinuz /var/lib/tftpboot/images/pxeboot")
    command_syn("cp /var/lib/tftpboot/initrd.img /var/lib/tftpboot/images/pxeboot")
    chmod_by_file("/var/lib/tftpboot/images")

    grub = "/var/lib/tftpboot/grub.cfg"
    alter(grub, '''set default="1"''', '''set default="0"''')
    s = " %s \n" % iso_name[:-4]
    alter_after(grub, "search --no-floppy --set=root -l", s)
    add_ip = "        set root=(tftp,%s)\n" % ip
    add_after(grub, "menuentry 'Install FusionOS 23'", add_ip)
    add_after(grub, "menuentry 'Test this media & install FusionOS", add_ip)
    s = "@60me inst.ks=http://%s/ks/FusionOS-ks.cfg\n" % ip
    alter_after(grub, "@60me", s)

    alter(grub, "inst.stage2=hd:LABEL=FusionOS-23-aarch64", "")


def add_yum_from_iso():
    iso = "/home/FusionOS"
    file_names = get_file_by_path(iso)
    iso_name = ""
    tar_name = ""
    iso_num, tar_num = 0, 0
    for s in file_names:
        if s[-3:] == "iso":
            iso_name = s
            iso_num += 1
        if s[-2:] == "gz":
            tar_name = s
            tar_num += 1
    if iso_num == 0:
        logging.info("iso does not exist in the /home/FusionOS, is the path wrong or forgot to import?")
    if tar_num == 0:
        logging.info("The tar package does not exist in the /home/FusionOS, is it a wrong path or forgot to import?")
    if iso_num > 1:
        logging.info("There are multiple iso, the last one will be selected as the default")
    if tar_num > 1:
        logging.info("There are multiple tar, the last one will be selected as the default")

    if iso_name[-11:-4] == "aarch64":
        logging.info("After judgment, the server version is arm64")
    else:
        logging.info("After judgment, the server version is x86")
    chmod_by_file('/mnt')
    chmod_by_file('/home/FusionOS/')

    s2 = 'mkdir -m 755 -p /home/FusionOS/srv/repo/'
    s3 = 'cp -r /mnt/Packages /home/FusionOS/srv/repo/'
    s4 = 'cp -r /mnt/repodata /home/FusionOS/srv/repo'
    s5 = 'cp -r /mnt/RPM-GPG-KEY-FusionOS /home/FusionOS/srv/repo/'
    s = 'mount /home/FusionOS/%s /mnt/' % iso_name
    command_syn(s)
    command_syn(s2)
    command_syn(s3)
    command_syn(s4)
    command_syn(s5)
    file = "/etc/yum.repos.d/FusionOS.repo"
    file_data = '''[base]
name=base
baseurl=file:///home/FusionOS/srv/repo
enabled=1
gpgcheck=1
gpgkey=file:///home/FusionOS/srv/repo/RPM-GPG-KEY-FusionOS
[update]
name=update
baseurl=file:///home/FusionOS/srv/update/
enabled=0
gpgcheck=1
gpgkey=file:///home/FusionOS/srv/repo/RPM-GPG-KEY-FusionOS '''

    insert(file, file_data)
    if tar_num >= 1:
        command_syn('mkdir -m 755 -p /home/FusionOS/srv/update')
        s = 'tar -xf /home/FusionOS/%s -C /home/FusionOS/srv/update' % tar_name
        command_syn(s)
        command_syn('dnf install createrepo -y')
        command_syn('createrepo /home/FusionOS/srv/update')

        alter(file, "enabled=0", "enabled=1")


# if client is in secureboot mode, modify filename from grubx64.efi(grubaa64.efi) to BOOTX64.EFI(BOOTAA64.EFI)
def add_dhcp(ip, version):
    command_syn("dnf install dhcp -y")
    command_syn("cp /usr/share/doc/dhcp-server/dhcpd.conf.example /etc/dhcp/dhcpd.conf")
    chmod_by_file("/etc/dhcp/dhcpd.conf")

    dhcpd = "/etc/dhcp/dhcpd.conf"
    file = '''# DHCP Server Configuration file.
#   see /usr/share/doc/dhcp-server/dhcpd.conf.example
#   see dhcpd.conf(5) man page
#
ddns-update-style interim;
ignore client-updates;

subnet 192.168.122.0 netmask 255.255.255.0 { 
    option routers 192.168.122.1; 
    option subnet-mask 255.255.255.0; 
    range dynamic-bootp 192.168.122.50 192.168.122.200;  
    default-lease-time 21600; 
    max-lease-time 43200; 
    filename "grubx64.efi";
    next-server 192.168.122.1;
}'''
    with open(dhcpd, "w", encoding="utf-8") as f:
        f.write(file)
        f.close()

    dic = read_csv("/etc/auto-pxe/network.csv")
    try:
        routers = dic["routers"]
        netmask = dic["netmask"]
        dynamic_bootp = dic["dynamicBootp"]
        subnet = dic["subnet"]
    except KeyError:
        logging.info("Network configuration missing entries, please fill in")
    if version == 1:
        filename = "grubaa64.efi"
    else:
        filename = "grubx64.efi"
    alter(dhcpd, "192.168.122.0", subnet)
    alter(dhcpd, "255.255.255.0", netmask)
    line_break = ";\n"
    alter_after(dhcpd, "option routers ", routers + line_break)
    alter_after(dhcpd, "option subnet-mask ", netmask + line_break)
    alter_after(dhcpd, "range dynamic-bootp ", dynamic_bootp + line_break)
    s = ''' "%s"%s''' % (filename, line_break)
    alter_after(dhcpd, "filename ", s)
    alter_after(dhcpd, "next-server ", ip + line_break)
    command_syn("systemctl start dhcpd")
    command_syn("systemctl enable dhcpd")


def get_file_by_path(path):
    output = subs.check_output(['/usr/bin/ls', '%s' % path])
    output = output.decode()[:-1]
    files = output.split("\n")
    return files


def chmod_by_file(path):
    s = 'chmod -R 755 %s' % path
    command_syn(s)


def command_syn(command):
    li = command.split(' ')
    p = subs.run(li)
